"
jv:libgdbs - GNU Debugger Interface Library
Copyright (C) 2015-now Jan Vrany
Copyright (C) 2022 LabWare

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the 'Software'), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
"
"{ Package: 'jv:vdb' }"

"{ NameSpace: Smalltalk }"

GDBDebuggerObject subclass:#VDBAddress
	instanceVariableNames:'value'
	classVariableNames:''
	poolDictionaries:''
	category:'VDB-Expressions'
!

!VDBAddress class methodsFor:'documentation'!

copyright
"
jv:libgdbs - GNU Debugger Interface Library
Copyright (C) 2015-now Jan Vrany
Copyright (C) 2022 LabWare

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the 'Software'), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
"
! !

!VDBAddress class methodsFor:'instance creation'!

value: aString
    ^ self new setValue: aString

    "Created: / 10-11-2019 / 23:25:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!VDBAddress methodsFor:'accessing'!

disassemble
    | result disassembly arch |

    result := debugger send: (GDBMI_data_disassemble arguments: (Array with: '-a' with: value with: '--' with: 5)).

    disassembly := result propertyAt: 'asm_insns'.
    arch := debugger selectedInferior threads anyOne stack first arch.
    disassembly do:[:each | each setDebugger: debugger; setArchitecture: arch ].
    ^ disassembly

    "Created: / 10-11-2019 / 23:26:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!VDBAddress methodsFor:'converting'!

asString
    ^ '0x' , value hexPrintString

    "Created: / 10-11-2019 / 23:39:42 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!VDBAddress methodsFor:'initialization'!

setValue: aString
    value := aString

    "Created: / 10-11-2019 / 23:24:46 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!VDBAddress class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

