"
jv:libgdbs - GNU Debugger Interface Library
Copyright (C) 2015-now Jan Vrany
Copyright (C) 2022 LabWare

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the 'Software'), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
"
"{ Package: 'jv:vdb' }"

"{ NameSpace: Smalltalk }"

GDBDebuggerObject subclass:#VDBAddressRange
	instanceVariableNames:'start end'
	classVariableNames:''
	poolDictionaries:''
	category:'VDB-Expressions'
!

!VDBAddressRange class methodsFor:'documentation'!

copyright
"
jv:libgdbs - GNU Debugger Interface Library
Copyright (C) 2015-now Jan Vrany
Copyright (C) 2022 LabWare

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the 'Software'), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
"
! !

!VDBAddressRange class methodsFor:'instance creation'!

from: startAddr to: endAddr
    ^ self new setStart: startAddr end: endAddr

    "Created: / 21-10-2019 / 00:02:40 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!VDBAddressRange methodsFor:'accessing'!

disassemble
    | result disassembly arch |

    result := debugger send: (GDBMI_data_disassemble arguments: (Array with: '-s' with: start value with: '-e' with: end value with: '--' with: 5)).

    disassembly := result propertyAt: 'asm_insns'.
    disassembly isNil ifTrue:[  
        "/ Empty range?
        disassembly := #()
    ] ifFalse:[
        arch := debugger selectedInferior threads anyOne stack first arch.
        disassembly do:[:each | each setDebugger: debugger; setArchitecture: arch ].
    ].
    ^ disassembly

    "Created: / 21-10-2019 / 00:26:41 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 22-05-2020 / 14:07:22 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!VDBAddressRange methodsFor:'converting'!

asString
    ^ start asString , ' , ' , end asString

    "Created: / 10-11-2019 / 23:40:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!VDBAddressRange methodsFor:'initialization'!

setStart: startAddr end: endAddr
    start := startAddr.
    end := endAddr.

    "Created: / 20-10-2019 / 23:47:39 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!VDBAddressRange class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

